/**
 *
 * Copyright (c) 2001, Frank Bu
 *
 * project: Formula
 * version: $Revision: 1.3 $ $Name:  $
 *
 * The Formula class is the facade class for accessing the fomula system.
 */

// disable "identifier was truncated to 255 characters in the debug information"
#pragma warning(disable : 4786)

#include "Formula.h"
#include "Parser.h"

Formula::Formula()
{
	m_parser = new Parser("");
}

Formula::Formula(string expression)
{
	m_parser = new Parser(expression);
}

Formula::~Formula()
{
	delete m_parser;
}

void Formula::setExpression(string expression)
{
	m_parser->setExpression(expression);
}


void Formula::setVariable(string name, double value)
{
	m_parser->setVariable(name, value);
}



void Formula::removeVariable(string name)
{
	m_parser->removeVariable(name);
}



void Formula::removeAllVariables()
{
	m_parser->removeAllVariables();
}



void Formula::setFunction(string name, double(*function)())
{
	m_parser->setFunction(name, function);
}



void Formula::setFunction(string name, double(*function)(double))
{
	m_parser->setFunction(name, function);
}



void Formula::setFunction(string name, double(*function)(double, double))
{
	m_parser->setFunction(name, function);
}



void Formula::removeFunction(string name)
{
	m_parser->removeFunction(name);
}



void Formula::removeAllFunctions()
{
	m_parser->removeAllFunctions();
}



double Formula::eval() throw(FunctionNotFound, VariableNotFound)
{
	return m_parser->eval();
}
