/**
 *
 * Copyright (c) 2001, Frank Bu
 *
 * project: LSystem
 * modul:   Test
 * version: $Revision: 1.2 $ $Name:  $
 *
 * CppUnit Testklasse fr Expression.
 */

// disable "identifier was truncated to 255 characters in the debug information"
#pragma warning(disable : 4786)

#include "test.h"
#include "TestAction.h"

#include <string>

#include <Evaluator.h>

using namespace std;

void TestAction::testNumber()
{
	NumberStack stack;
	NumberAction n(1.2);
	n.run(stack);
	assert(stack.size() == 1);
	assert(stack.top() == 1.2);
}


void TestAction::testAdd()
{
	NumberStack stack;
	AddAction add;
	stack.push(1);
	stack.push(2);
	add.run(stack);
	assert(stack.size() == 1);
	assert(stack.top() == 3);
}


void TestAction::testMul()
{
	NumberStack stack;
	MulAction mul;
	stack.push(3);
	stack.push(4);
	mul.run(stack);
	assert(stack.size() == 1);
	assert(stack.top() == 12);
}


void TestAction::testPower()
{
	NumberStack stack;
	PowerAction pow;
	stack.push(3);
	stack.push(4);
	pow.run(stack);
	assert(stack.size() == 1);
	assert(stack.top() == 81);
}


Test *TestAction::suite ()
{
	TestSuite *testSuite = new TestSuite("TestExpression");

    testSuite->addTest(new TestCaller <TestAction> ("testNumber", testNumber));
    testSuite->addTest(new TestCaller <TestAction> ("testAdd", testAdd));
    testSuite->addTest(new TestCaller <TestAction> ("testMul", testMul));
    testSuite->addTest(new TestCaller <TestAction> ("testPower", testPower));

	return testSuite;
}
